//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATEFUNCTIONWIDGET1_H
#define KPGCREATEFUNCTIONWIDGET1_H

#include "kpgcreatefunctionwidget1base.h"

class KPGDatabase;

/**
Widget for create function Wizard

@author Lumir Vanek
*/

class KPGCreateFunctionWidget1 : public KPGCreateFunctionWidget1Base
{
Q_OBJECT
public:
    KPGCreateFunctionWidget1(QWidget *parent, const char *name, KPGDatabase *);
    ~KPGCreateFunctionWidget1();
    
    void initialize();
    void refreshListOfLanguages();
    void refreshListOfTypes();
		const QString getFuncNameParams() const;
		const QString getSQL() const;

protected:
    KPGDatabase *m_pDatabase;    
    
protected slots:

    virtual void slotFunctionNameChanged(const QString&);
		virtual void slotSchemaActivated(const QString &);
    virtual void slotComboReturnTypeActivated(const QString &);
    virtual void slotComboArgumentTypeActivated(const QString &);
    
		virtual void slotArgumentsSelectChanged(QListBoxItem *);
		
    virtual void slotArgumentAdd();
    virtual void slotArgumentDelete();
    virtual void slotArgumentUp();
    virtual void slotArgumentDown();
    
signals:
    void sigEnableNextButton(bool);   
};

#endif
