//
// C++ Implementation: kpgcreategroupwidget1
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgcreategroupwidget1.h"

// include files for Qt
#include <qpushbutton.h>

// include files for KDE
#include <klistbox.h>
#include <klineedit.h>
#include <kmessagebox.h>
#include <kdebug.h>

// application specific includes
#include "../DbObjects/kpgtreeitem.h"
#include "../DbObjects/kpgconnection.h"
#include "../kpgsqldialog.h"

KPGCreateGroupWidget1::KPGCreateGroupWidget1(QWidget *parent, const char *name)
 : KPGCreateGroupWidget1Base(parent, name)
{
	m_pLineEditGroupName->setFocus();
}


KPGCreateGroupWidget1::~KPGCreateGroupWidget1()
{
}

// Set connection for wizard operation
void KPGCreateGroupWidget1::setConnection(KPGConnection * pDbConnection)
{
	m_pDbConnection = pDbConnection;
}

void KPGCreateGroupWidget1::slotLineEditGroupNameChanged(const QString &strUserName)
{
	emit sigEnableNextButton(strUserName.length() > 0);
}

void KPGCreateGroupWidget1::slotAvailableUsersSelectChanged(QListBoxItem* pSelectedItem)
{
	m_pPushButtonUserAdd->setEnabled(pSelectedItem != 0);
}
		
void KPGCreateGroupWidget1::slotUsersInGroupSelectChanged(QListBoxItem* pSelectedItem)
{
	m_pPushButtonUserDelete->setEnabled(pSelectedItem != 0);
}

void KPGCreateGroupWidget1::slotUserAdd()
{
	QListBoxItem *pSelectedItem = m_pListBoxAvailUsers->selectedItem();
	if(!pSelectedItem) return;
	
	// Move user from available list to user list 
	m_pListBoxUsersInGroup->insertItem(* pSelectedItem->pixmap(), pSelectedItem->text());
		
	m_pListBoxAvailUsers->removeItem(m_pListBoxAvailUsers->currentItem());
	m_pPushButtonUserAdd->setEnabled(false);
}

void KPGCreateGroupWidget1::slotUserDelete()
{
	QListBoxItem *pSelectedItem = m_pListBoxUsersInGroup->selectedItem();
	if(!pSelectedItem) return;
	
	m_pListBoxAvailUsers->insertItem(* pSelectedItem->pixmap(), pSelectedItem->text());
	m_pListBoxUsersInGroup->removeItem(m_pListBoxUsersInGroup->currentItem());
	
	m_pPushButtonUserDelete->setEnabled(false);
}		
		
// Return part of SQL statement for CREATE VIEW
const QString KPGCreateGroupWidget1::getSQL() const
{
	QString strSQL(m_pLineEditGroupName->text());
	
	QString strWITH(" WITH\n");
	
	if(m_pLineEditSysId->text().length() > 0)
	{
		strWITH.append("SYSID " + m_pLineEditSysId->text() + "\n");
	}

	for(unsigned int i = 0; i < m_pListBoxUsersInGroup->count(); i++)
	{
		if(i > 0)
			strWITH.append(", ");
		else
			strWITH.append("USER ");
			
		strWITH.append(m_pListBoxUsersInGroup->item(i)->text());
	}
	
	if(strWITH.length() > 7)
		strSQL.append(strWITH);
		
	return strSQL;
}


#include "kpgcreategroupwidget1.moc"
