//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgcreatetablecolumnwizard.h"

// include files for Qt
#include <qcheckbox.h>
#include <qframe.h> 
#include <qlayout.h>
#include <qpushbutton.h>
#include <qlistview.h>

// include files for KDE
#include <kdebug.h>
#include <klineedit.h>
#include <ktextedit.h>
#include <klistbox.h>
#include <kcombobox.h>
#include <kmessagebox.h>
#include <klocale.h>

// application specific includes
#include "../DbObjects/kpgconnection.h"
#include "../DbObjects/kpgdatabase.h"
#include "../DbObjects/kpgschema.h"
#include "../DbObjects/kpgtablecolumnsfolder.h"
#include "../DbObjects/kpgtablesfolder.h"
#include "../DbObjects/kpgtablespacesfolder.h"
#include "kpgcreatetablewidget2.h"


KPGCreateTableColumnWizard::KPGCreateTableColumnWizard(QWidget *parent, const char *name, KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable)
 : KPG3StepsWizard(parent, name)
{
  m_pDatabase = pDatabase;
  m_strTableName = pTable->text(0);
  m_strNamespace = pSchema->text(0); 
  
  KPGCreateTableWidget2 *pCreateTableWidget2 = new KPGCreateTableWidget2(WizardPage1, "KPGCreateTableWidget2");
  m_pPageWidget1 = pCreateTableWidget2;
  WizardPage1Layout->addWidget(m_pPageWidget1, 0, 0);
  connect(pCreateTableWidget2, SIGNAL(sigEnableNextButton(bool)), this, SLOT(slotEnableNextButton1(bool)));
        
  pCreateTableWidget2->m_pLineEditColumnName->setFocus();
  
  languageChange();
}


KPGCreateTableColumnWizard::~KPGCreateTableColumnWizard()
{
}


void KPGCreateTableColumnWizard::languageChange()
{
    KPG3StepsWizard::languageChange();
    
    setCaption( i18n( "Add Column to Table" ) );
    
    setTitle( WizardPage1, i18n( "Step 1 - Define table column(s)" ) );
    setTitle( WizardPage2, i18n( "Step 2 - Review SQL statement" ) );
    setTitle( WizardPage3, i18n( "Step 3 - Check operation result" ) );
}

// When this function called, initialize appropriate Wizard page
void KPGCreateTableColumnWizard::showPage(QWidget *pPage)
{
  if(pPage == WizardPage2) // Step 2 - Review SQL statement
  {
    KPGCreateTableWidget2 *pCreateTableWidget2 = static_cast <KPGCreateTableWidget2 *> (m_pPageWidget1);
    
    // prepare SQL statement
    QString strSQL;
    
    QListViewItem * pItem = pCreateTableWidget2->m_pListViewColumns->firstChild();
    while(pItem)
    {
      strSQL.append("ALTER TABLE ");
      strSQL.append(m_strNamespace);
      strSQL.append(".");
      strSQL.append(m_strTableName);
      strSQL.append(" ADD COLUMN ");
      strSQL.append(pItem->text(0));
      strSQL.append(" ");
      strSQL.append(pItem->text(1));
      strSQL.append(";\n");
      
      pItem = pItem->nextSibling();
    }
    
    m_pTextEditSQL->setText(strSQL);
  }
  
  if(pPage == WizardPage3) // Step 3 - Check operation result
  {
    // Run SQL statement
    if(m_pDatabase == 0)
    {
      kdError() << "KPGCreateTableColumnWizard::showPage - Database not connected to server !" << endl;
      m_pTextEditResult->setText("Database not connected to server !");
    }
    else
    { 
      try
      {   
        pqxx::result R = m_pDatabase->runQuery(m_pTextEditSQL->text());
        m_pTextEditResult->setText(i18n("Operation successfull"));
        setFinishEnabled(WizardPage3, true);
      }
      catch (const std::exception &e)
      {
        m_pTextEditResult->setText(e.what());
      } 
    }
  }

  // call parent
  KPG3StepsWizard::showPage(pPage);
}

#include "kpgcreatetablecolumnwizard.moc"
