//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgmodifytablespacewidget1.h"

#include <kcombobox.h>
#include <klineedit.h>
#include <kurlrequester.h>

// application specific includes
#include "../DbObjects/kpgtablespace.h"

KPGModifyTablespaceWidget1::KPGModifyTablespaceWidget1(QWidget *parent, const char *name, KPGTablespace *pTablespace)
 : KPGCreateTablespaceWidget1(parent, name)
{
  m_pTablespace = pTablespace;
  
  m_pLineEditTablespaceName->setText(pTablespace->text(0));
  m_pURLRequesterPath->setURL(pTablespace->location());
  m_pURLRequesterPath->setEnabled(false);
}


KPGModifyTablespaceWidget1::~KPGModifyTablespaceWidget1()
{
}

void KPGModifyTablespaceWidget1::slotTablespaceNameChanged(const QString &strTablespaceName)
{
   emit sigEnableNextButton((getSQL().length() > 0) && (strTablespaceName.length() > 0));
}

void KPGModifyTablespaceWidget1::slotOwnerActivated(const QString &)
{
   emit sigEnableNextButton((getSQL().length() > 0) && (!m_pLineEditTablespaceName->text().isEmpty()));
}

// Return part of SQL statement for ALTER TABLESPACE
const QString KPGModifyTablespaceWidget1::getSQL() const
{
  QString strSQL; 
  
    
  if(m_pComboBoxOwner->currentText() != m_pTablespace->owner())
  {
    strSQL.append("ALTER TABLESPACE " + m_pTablespace->text(0));
    strSQL.append(" OWNER TO ");
    strSQL.append(m_pComboBoxOwner->currentText());
    strSQL.append(";\n");
  }
  
  if(m_pLineEditTablespaceName->text() != m_pTablespace->text(0))
  {
    strSQL.append("ALTER TABLESPACE ");
    strSQL.append(m_pTablespace->text(0));
    strSQL.append(" RENAME TO ");
    strSQL.append(m_pLineEditTablespaceName->text());
    strSQL.append(";");
  } 
    
  return strSQL;
}


#include "kpgmodifytablespacewidget1.moc"
