//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgmodifytablespacewizard.h"


// include files for Qt
#include <qlayout.h>

// include files for KDE
#include <kdebug.h>
#include <ktextedit.h>
#include <klineedit.h>
#include <kcombobox.h>
#include <kurlrequester.h>
#include <kmessagebox.h>
#include <klocale.h>

// application specific includes
#include "../DbObjects/kpgserver.h"
#include "../DbObjects/kpgconnection.h"
#include "../DbObjects/kpgusersfolder.h"
#include "../DbObjects/kpggroupsfolder.h"
#include "../DbObjects/kpgtablespace.h"
#include "kpgmodifytablespacewidget1.h"


KPGModifyTablespaceWizard::KPGModifyTablespaceWizard(QWidget *parent, const char *name, KPGServer *pServer, KPGTablespace *pTablespace)
 : KPG3StepsWizard(parent, name)
{
    KPGModifyTablespaceWidget1 *pModifyTablespaceWidget = new KPGModifyTablespaceWidget1(WizardPage1, "KPGModifyTablespaceWidget1", pTablespace);
  m_pPageWidget1 = pModifyTablespaceWidget;
  WizardPage1Layout->addWidget(m_pPageWidget1, 0, 0);
  connect(pModifyTablespaceWidget, SIGNAL(sigEnableNextButton(bool)), this, SLOT(slotEnableNextButton1(bool)));
  
  pModifyTablespaceWidget->m_pComboBoxOwner->clear(); // remove DEFAULT item
  pServer->getUsersFolder()->fillComboBoxWithChildItems(pModifyTablespaceWidget->m_pComboBoxOwner);
  pModifyTablespaceWidget->m_pComboBoxOwner->setCurrentText(pTablespace->owner());
    
  languageChange();
}


KPGModifyTablespaceWizard::~KPGModifyTablespaceWizard()
{
}

void KPGModifyTablespaceWizard::languageChange()
{
    KPG3StepsWizard::languageChange();
    
    setCaption( i18n( "Modify tablespace" ) );
    
    setTitle( WizardPage1, i18n( "Step 1 - Tablespace name and owner" ) );
    setTitle( WizardPage2, i18n( "Step 2 - Review SQL statement" ) );
    setTitle( WizardPage3, i18n( "Step 3 - Check operation result" ) );
}

// When this function called, initialize appropriate Wizard page
void KPGModifyTablespaceWizard::showPage(QWidget *pPage)
{ 
  if(pPage == WizardPage2) // Step 2 - Review SQL statement
  {
    // prepare SQL statement
    QString strSQL;
    
    strSQL.append((static_cast <KPGModifyTablespaceWidget1 *> (m_pPageWidget1))->getSQL());
     
    m_pTextEditSQL->setText(strSQL);
  }
  
  if(pPage == WizardPage3) // Step 3 - Check operation result
  {
    // Run SQL statement
    if(m_pConnection == 0)
    {
      kdError() << "KPGModifyTablespaceWizard::showPage - Database not connected to server !" << endl;
      m_pTextEditResult->setText("Database not connected to server !");
    }
    else
    { 
      try
      {   
        pqxx::result R = m_pConnection->runQuery(m_pTextEditSQL->text(), KPGConnection::eTransNone);
        m_pTextEditResult->setText(i18n("Operation successfull"));
        setFinishEnabled(WizardPage3, true);
      }
      catch (const std::exception &e)
      {
        m_pTextEditResult->setText(e.what());
      } 
    }
  }
  
  // call parent
  KPG3StepsWizard::showPage(pPage);
}


#include "kpgmodifytablespacewizard.moc"
